import{s as $t,o as St,n as bt}from"../chunks/scheduler.65852ee5.js";import{S as Lt,i as Ct,g as r,s as n,r as p,A as Ht,h as s,f as o,c as i,j as vt,u as d,x as l,k as v,y as Tt,a,v as f,d as h,t as m,w as y}from"../chunks/index.aa74147d.js";import{T as wt}from"../chunks/Tip.bb8ccac8.js";import{H as M,E as kt}from"../chunks/EditOnGithub.4eda6a96.js";function xt(ne){let c,g="When you actively work with the Space over several days or weeks, files can accumulate in the storage cache. When you get a warning that the persistent storage is full and you think that the storage quota should not be reached yet, it might be helpful to factory reset the Space to empty the cache.";return{c(){c=r("p"),c.textContent=g},l(u){c=s(u,"P",{"data-svelte-h":!0}),l(c)!=="svelte-12w8m1d"&&(c.textContent=g)},m(u,w){a(u,c,w)},p:bt,d(u){u&&o(c)}}}function Mt(ne){let c,g="Persisted files in the <code>/data</code> directory are currently not automatically backed up. We therefore recommend making backups of your most important files on a regular basis to avoid accidental data loss.";return{c(){c=r("p"),c.innerHTML=g},l(u){c=s(u,"P",{"data-svelte-h":!0}),l(c)!=="svelte-18m0xw9"&&(c.innerHTML=g)},m(u,w){a(u,c,w)},p:bt,d(u){u&&o(c)}}}function _t(ne){let c,g,u,w,_,re,P,ze="Services like Google Colab or Kaggle Notebooks have made it dramatically easier for people to access compute in easy-to-use Jupyter notebooks in the browser. Unfortunately, these services also have several limitations:",se,D,We="<li>GPUs are unstable, and a training job can be canceled right before it finishes.</li> <li>The choice of GPUs is limited to just a few single GPUs.</li> <li>There is no native support for connecting to the cloud GPU via your preferred local IDE like VS Code.</li>",le,J,qe="HF JupyterLab Spaces overcome these limitations. With a HF JupyterLab Space, you can:",ce,j,Re="<li>Do all of your development work in JupyterLab in your browser.</li> <li>Dynamically switch between CPUs and a wide range of GPUs that never stop unless you want them to.</li> <li>Connect to cloud compute resources with your preferred local IDE like VS Code via SSH for full remote development.</li>",ue,I,Ne="This recipe guides you through the setup of your own JupyterLab Space.",pe,E,de,U,fe,F,Ke='To create your own HF JupyterLab Space, navigate to the <a href="https://huggingface.co/new-space?template=SpacesExamples%2Fjupyterlab" rel="nofollow">Space creation page</a> and click on <code>Docker</code> &gt; <code>JupyterLab</code>. A HF JupyterLab Space is essentially a Docker container with a pre-configured copy of JupyterLab that runs on Hugging Face’s cloud infrastructure. Here is some advice on configuring your JupyterLab Space:',he,G,Be='<li><strong>Choosing the correct owner</strong>: If you are using the JupyterLab Space as part of your work for an Enterprise Hub Organization, select the organization’s name under the <code>Owner</code> dropdown (e.g. the dummy “enterprise-explorers” in the image below). Any compute costs will then be billed on the account of this Enterprise Organization.</li> <li><strong>Access control</strong>: If you want only selected members of your team to access the JupyterLab Space, you can click on <code>Everyone</code> right next to <code>Access Control</code> and limit access to the JupyterLab Space to a predefined Resource Group. Resource Groups are an Enterprise Hub feature that enables you to limit access to selected repositories (models, datasets, Spaces) to a smaller group of team members. See the <a href="https://huggingface.co/docs/hub/en/security-resource-groups" rel="nofollow">docs</a> on how to create your first Resource Group.</li>',me,b,Qe='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-creation-1.png" width="450"/>',ye,V,Xe='<li><strong>Choosing your hardware</strong>: You can choose from a wide range of hardware from free CPUs to A100 GPUs. When setting up the Space, we recommend you choose the free basic CPU. You can switch to better paid hardware once you need it (see available hardware and prices <a href="https://huggingface.co/pricing" rel="nofollow">here</a>).</li> <li><strong>Persistent storage</strong>: It is important to attach persistent storage to the Space, so that all the files you create (code, models, data) are also saved when the Space is paused or reset. You can always increase the disk space in the settings later when necessary. All persistent data is stored in the <code>/data</code> directory (<a href="https://huggingface.co/docs/hub/en/spaces-storage" rel="nofollow">docs</a>).</li> <li><strong>Set your password</strong>: Once the Space is created, it will require a password for logging into JupyterLab. This password is defined with the <code>JUPYTER_TOKEN</code> Space secret. If you do not define a password here, the default password is “huggingface”. We recommend setting a strong password.</li> <li><strong>Dev Mode</strong>: Dev Mode is a feature for Enterprise Hub subscribers that enables you to SSH into any HF Space. Activate this to connect your local VS Code for remote development on the Space’s cloud hardware (this can also be switched on/off later). See the preview docs <a href="https://huggingface.co/dev-mode-explorers" rel="nofollow">here</a>.</li> <li><strong>Private Spaces</strong>: As an additional layer of security, we recommend setting the Space to private, so that only members of your Enterprise Organization (and of specific Resource Groups) can see it.</li>',ge,$,Ze='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-creation-2.png" width="450"/>',ve,A,et="Once you have configured the JupyterLab Space, you can click on <code>Create Space</code>. The Space will be built and after a few seconds you will see the JupyterLab login screen. You can now login with the password you defined before.",we,S,tt='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-login.png"/>',be,O,$e,Y,ot="You can now work in your own JupyterLab Space in the browser! You can create your own directory structure with .ipynb notebooks or any other files and datasets in the File Browser on the left. If you have activated persistent storage, all files are permanently stored in the default <code>/data</code> directory of the Space.",Se,L,at='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-first-notebook.png"/>',Le,z,Ce,W,nt="Similar to services like Google Colab, you can change the hardware the Space is running on-the-fly. We recommend doing initial setup work on the upgraded or free CPU, for example data cleaning, setting up Endpoints, or testing APIs. Once your code is set up, you can simply click on <code>Settings</code> at the top right of the Space and change to a wide selection of hardware that might be required for more compute intensive inference or training jobs. When you change hardware, the Space will restart itself and all environment variables will be lost (like with Google Colab) and you will have a new clean environment on the new hardware after some seconds. Your stored and saved files (code, data etc.) will of course also be available on the new hardware. The image below shows the available hardware at the time of writing (June 2024) and this will be updated in the future.",He,q,it="In the bottom left of the image, you can also see the <code>Sleep time settings</code> where you can define how long you want the hardware to run in case of inactivity. This is a major advantage over Google Colab. If you want to save money, you can make the Space sleep after 15 minutes of inactivity, but if you need the hardware to be available for a 48 hour training run or longer, you can just prevent the Space from falling asleep and let it run for as long as you want. You can also manually <code>Pause</code> the Space and you will no longer be charged for the Space Hardware.",Te,C,rt='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-hardware-options.png"/>',ke,R,st="If you scroll down in the settings, you will see additional options, like expanding storage, resetting the Space, etc. In case you have not set a password during Space creation, you can also create a secret called <code>JUPYTER_TOKEN</code> here later, which will replace the default “huggingface” password.",xe,H,Me,N,_e,K,lt="Remember that your JupyterLab Space is just a pre-configured Docker container, so if you are familiar with Docker, you can also customize it to your needs. For example, you can go to the <code>Files</code> section of your Space and add new requirements to the <code>requirements.txt</code> file or you can change from the default container image to another image in the <code>Dockerfile</code>, e.g. if you need a specific CUDA and PyTorch version preinstalled.",Pe,T,ct='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-files.png"/>',De,B,Je,Q,ut='What if you don’t like working in JupyterLab in the browser? Enter <code>Dev Mode</code>. <code>Dev Mode</code> enables you to SSH into any Space’s hardware from a local IDE like VS Code. <a href="https://huggingface.co/pricing" rel="nofollow">HF Pro/Enterprise</a> subscribers can activate <code>Dev Mode</code> for any Space in the Space’s settings.',je,X,pt='Once <code>Dev Mode</code> is activated, you will see a pop-up at the bottom left of your JupyterLab Space’s window. To SSH into your local VS Code, you first need to install the <a href="https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-ssh" rel="nofollow">VS Code Remote - SSH extension</a> locally and add your SSH key to your <a href="https://huggingface.co/settings/keys" rel="nofollow">HF Profile</a>. Clicking on <code>Connect with VS Code</code> should then open your local VS Code window and establish the remote connection to your Space. A similar process should be possible with any IDE that supports remote development with SSH.',Ie,k,dt='<img src="https://huggingface.co/datasets/huggingface/cookbook-images/resolve/main/enterprise-jupyterlab-devmode-popup.png" width="450"/>',Ee,Z,ft="When connecting to your Space with SSH, your default directory will be an empty <code>/app</code> directory. You then need to change to the <code>/data</code> directory, where all your persistent files (code, data, models etc.) are stored. The <code>/data</code> directory is the only directory with guaranteed file persistance across sessions. You can find the files of your Docker container in the <code>HOME/user/app</code> directory, in case you want to modify the underlying Docker container.",Ue,x,Fe,ee,Ge,te,ht="That’s it, you can now run a JupyterLab Space in your browser, switch between one or multiple powerful GPUs on-the-fly, and connect to the hardware from your local IDE.",Ve,oe,mt="This entire recipe was written in a JupyterLab Space on a free CPU and we invite you to follow all other recipes of the Enterprise Hub Cookbook in your own JupyterLab Space.",Ae,ae,Oe,ie,Ye;return _=new M({props:{title:"Interactive Development In HF Spaces",local:"interactive-development-in-hf-spaces",headingTag:"h1"}}),E=new M({props:{title:"Interactive Development in HF JupyterLab Spaces",local:"interactive-development-in-hf-jupyterlab-spaces",headingTag:"h2"}}),U=new M({props:{title:"Creating your JupyterLab Space",local:"creating-your-jupyterlab-space",headingTag:"h3"}}),O=new M({props:{title:"Using your JupyterLab Space",local:"using-your-jupyterlab-space",headingTag:"h3"}}),z=new M({props:{title:"Dynamically switching between CPUs and GPUs",local:"dynamically-switching-between-cpus-and-gpus",headingTag:"h3"}}),H=new wt({props:{warning:!1,$$slots:{default:[xt]},$$scope:{ctx:ne}}}),N=new M({props:{title:"Customizing your JupyterLab Space",local:"customizing-your-jupyterlab-space",headingTag:"h3"}}),B=new M({props:{title:"Dev Mode: Develop on HF Spaces from your local VS Code",local:"dev-mode-develop-on-hf-spaces-from-your-local-vs-code",headingTag:"h2"}}),x=new wt({props:{warning:!1,$$slots:{default:[Mt]},$$scope:{ctx:ne}}}),ee=new M({props:{title:"Now write some code!",local:"now-write-some-code",headingTag:"h2"}}),ae=new kt({props:{source:"https://github.com/huggingface/cookbook/blob/main/notebooks/en/enterprise_cookbook_dev_spaces.md"}}),{c(){c=r("meta"),g=n(),u=r("p"),w=n(),p(_.$$.fragment),re=n(),P=r("p"),P.textContent=ze,se=n(),D=r("ul"),D.innerHTML=We,le=n(),J=r("p"),J.textContent=qe,ce=n(),j=r("ul"),j.innerHTML=Re,ue=n(),I=r("p"),I.textContent=Ne,pe=n(),p(E.$$.fragment),de=n(),p(U.$$.fragment),fe=n(),F=r("p"),F.innerHTML=Ke,he=n(),G=r("ul"),G.innerHTML=Be,me=n(),b=r("div"),b.innerHTML=Qe,ye=n(),V=r("ul"),V.innerHTML=Xe,ge=n(),$=r("div"),$.innerHTML=Ze,ve=n(),A=r("p"),A.innerHTML=et,we=n(),S=r("div"),S.innerHTML=tt,be=n(),p(O.$$.fragment),$e=n(),Y=r("p"),Y.innerHTML=ot,Se=n(),L=r("div"),L.innerHTML=at,Le=n(),p(z.$$.fragment),Ce=n(),W=r("p"),W.innerHTML=nt,He=n(),q=r("p"),q.innerHTML=it,Te=n(),C=r("div"),C.innerHTML=rt,ke=n(),R=r("p"),R.innerHTML=st,xe=n(),p(H.$$.fragment),Me=n(),p(N.$$.fragment),_e=n(),K=r("p"),K.innerHTML=lt,Pe=n(),T=r("div"),T.innerHTML=ct,De=n(),p(B.$$.fragment),Je=n(),Q=r("p"),Q.innerHTML=ut,je=n(),X=r("p"),X.innerHTML=pt,Ie=n(),k=r("div"),k.innerHTML=dt,Ee=n(),Z=r("p"),Z.innerHTML=ft,Ue=n(),p(x.$$.fragment),Fe=n(),p(ee.$$.fragment),Ge=n(),te=r("p"),te.textContent=ht,Ve=n(),oe=r("p"),oe.textContent=mt,Ae=n(),p(ae.$$.fragment),Oe=n(),ie=r("p"),this.h()},l(e){const t=Ht("svelte-u9bgzb",document.head);c=s(t,"META",{name:!0,content:!0}),t.forEach(o),g=i(e),u=s(e,"P",{}),vt(u).forEach(o),w=i(e),d(_.$$.fragment,e),re=i(e),P=s(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-12kwx5y"&&(P.textContent=ze),se=i(e),D=s(e,"UL",{"data-svelte-h":!0}),l(D)!=="svelte-abb420"&&(D.innerHTML=We),le=i(e),J=s(e,"P",{"data-svelte-h":!0}),l(J)!=="svelte-btpwh7"&&(J.textContent=qe),ce=i(e),j=s(e,"UL",{"data-svelte-h":!0}),l(j)!=="svelte-ecynas"&&(j.innerHTML=Re),ue=i(e),I=s(e,"P",{"data-svelte-h":!0}),l(I)!=="svelte-i53sl"&&(I.textContent=Ne),pe=i(e),d(E.$$.fragment,e),de=i(e),d(U.$$.fragment,e),fe=i(e),F=s(e,"P",{"data-svelte-h":!0}),l(F)!=="svelte-1ep53u4"&&(F.innerHTML=Ke),he=i(e),G=s(e,"UL",{"data-svelte-h":!0}),l(G)!=="svelte-eptsyq"&&(G.innerHTML=Be),me=i(e),b=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(b)!=="svelte-1tonl05"&&(b.innerHTML=Qe),ye=i(e),V=s(e,"UL",{"data-svelte-h":!0}),l(V)!=="svelte-q8e75v"&&(V.innerHTML=Xe),ge=i(e),$=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l($)!=="svelte-16of21m"&&($.innerHTML=Ze),ve=i(e),A=s(e,"P",{"data-svelte-h":!0}),l(A)!=="svelte-9vvumy"&&(A.innerHTML=et),we=i(e),S=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(S)!=="svelte-5lbqpf"&&(S.innerHTML=tt),be=i(e),d(O.$$.fragment,e),$e=i(e),Y=s(e,"P",{"data-svelte-h":!0}),l(Y)!=="svelte-1u2x82h"&&(Y.innerHTML=ot),Se=i(e),L=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(L)!=="svelte-lmzl9m"&&(L.innerHTML=at),Le=i(e),d(z.$$.fragment,e),Ce=i(e),W=s(e,"P",{"data-svelte-h":!0}),l(W)!=="svelte-6tsul8"&&(W.innerHTML=nt),He=i(e),q=s(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-19e2tft"&&(q.innerHTML=it),Te=i(e),C=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(C)!=="svelte-149571n"&&(C.innerHTML=rt),ke=i(e),R=s(e,"P",{"data-svelte-h":!0}),l(R)!=="svelte-pc0o2j"&&(R.innerHTML=st),xe=i(e),d(H.$$.fragment,e),Me=i(e),d(N.$$.fragment,e),_e=i(e),K=s(e,"P",{"data-svelte-h":!0}),l(K)!=="svelte-1b1ttje"&&(K.innerHTML=lt),Pe=i(e),T=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(T)!=="svelte-1ghnffd"&&(T.innerHTML=ct),De=i(e),d(B.$$.fragment,e),Je=i(e),Q=s(e,"P",{"data-svelte-h":!0}),l(Q)!=="svelte-10uk794"&&(Q.innerHTML=ut),je=i(e),X=s(e,"P",{"data-svelte-h":!0}),l(X)!=="svelte-yreh8v"&&(X.innerHTML=pt),Ie=i(e),k=s(e,"DIV",{style:!0,"data-svelte-h":!0}),l(k)!=="svelte-ex5tk3"&&(k.innerHTML=dt),Ee=i(e),Z=s(e,"P",{"data-svelte-h":!0}),l(Z)!=="svelte-1tg94bn"&&(Z.innerHTML=ft),Ue=i(e),d(x.$$.fragment,e),Fe=i(e),d(ee.$$.fragment,e),Ge=i(e),te=s(e,"P",{"data-svelte-h":!0}),l(te)!=="svelte-1xx048t"&&(te.textContent=ht),Ve=i(e),oe=s(e,"P",{"data-svelte-h":!0}),l(oe)!=="svelte-v78tt5"&&(oe.textContent=mt),Ae=i(e),d(ae.$$.fragment,e),Oe=i(e),ie=s(e,"P",{}),vt(ie).forEach(o),this.h()},h(){v(c,"name","hf:doc:metadata"),v(c,"content",Pt),v(b,"style","flex justify-center"),v($,"style","flex justify-center"),v(S,"style","flex justify-center"),v(L,"style","flex justify-center"),v(C,"style","flex justify-center"),v(T,"style","flex justify-center"),v(k,"style","flex justify-center")},m(e,t){Tt(document.head,c),a(e,g,t),a(e,u,t),a(e,w,t),f(_,e,t),a(e,re,t),a(e,P,t),a(e,se,t),a(e,D,t),a(e,le,t),a(e,J,t),a(e,ce,t),a(e,j,t),a(e,ue,t),a(e,I,t),a(e,pe,t),f(E,e,t),a(e,de,t),f(U,e,t),a(e,fe,t),a(e,F,t),a(e,he,t),a(e,G,t),a(e,me,t),a(e,b,t),a(e,ye,t),a(e,V,t),a(e,ge,t),a(e,$,t),a(e,ve,t),a(e,A,t),a(e,we,t),a(e,S,t),a(e,be,t),f(O,e,t),a(e,$e,t),a(e,Y,t),a(e,Se,t),a(e,L,t),a(e,Le,t),f(z,e,t),a(e,Ce,t),a(e,W,t),a(e,He,t),a(e,q,t),a(e,Te,t),a(e,C,t),a(e,ke,t),a(e,R,t),a(e,xe,t),f(H,e,t),a(e,Me,t),f(N,e,t),a(e,_e,t),a(e,K,t),a(e,Pe,t),a(e,T,t),a(e,De,t),f(B,e,t),a(e,Je,t),a(e,Q,t),a(e,je,t),a(e,X,t),a(e,Ie,t),a(e,k,t),a(e,Ee,t),a(e,Z,t),a(e,Ue,t),f(x,e,t),a(e,Fe,t),f(ee,e,t),a(e,Ge,t),a(e,te,t),a(e,Ve,t),a(e,oe,t),a(e,Ae,t),f(ae,e,t),a(e,Oe,t),a(e,ie,t),Ye=!0},p(e,[t]){const yt={};t&2&&(yt.$$scope={dirty:t,ctx:e}),H.$set(yt);const gt={};t&2&&(gt.$$scope={dirty:t,ctx:e}),x.$set(gt)},i(e){Ye||(h(_.$$.fragment,e),h(E.$$.fragment,e),h(U.$$.fragment,e),h(O.$$.fragment,e),h(z.$$.fragment,e),h(H.$$.fragment,e),h(N.$$.fragment,e),h(B.$$.fragment,e),h(x.$$.fragment,e),h(ee.$$.fragment,e),h(ae.$$.fragment,e),Ye=!0)},o(e){m(_.$$.fragment,e),m(E.$$.fragment,e),m(U.$$.fragment,e),m(O.$$.fragment,e),m(z.$$.fragment,e),m(H.$$.fragment,e),m(N.$$.fragment,e),m(B.$$.fragment,e),m(x.$$.fragment,e),m(ee.$$.fragment,e),m(ae.$$.fragment,e),Ye=!1},d(e){e&&(o(g),o(u),o(w),o(re),o(P),o(se),o(D),o(le),o(J),o(ce),o(j),o(ue),o(I),o(pe),o(de),o(fe),o(F),o(he),o(G),o(me),o(b),o(ye),o(V),o(ge),o($),o(ve),o(A),o(we),o(S),o(be),o($e),o(Y),o(Se),o(L),o(Le),o(Ce),o(W),o(He),o(q),o(Te),o(C),o(ke),o(R),o(xe),o(Me),o(_e),o(K),o(Pe),o(T),o(De),o(Je),o(Q),o(je),o(X),o(Ie),o(k),o(Ee),o(Z),o(Ue),o(Fe),o(Ge),o(te),o(Ve),o(oe),o(Ae),o(Oe),o(ie)),o(c),y(_,e),y(E,e),y(U,e),y(O,e),y(z,e),y(H,e),y(N,e),y(B,e),y(x,e),y(ee,e),y(ae,e)}}}const Pt='{"title":"Interactive Development In HF Spaces","local":"interactive-development-in-hf-spaces","sections":[{"title":"Interactive Development in HF JupyterLab Spaces","local":"interactive-development-in-hf-jupyterlab-spaces","sections":[{"title":"Creating your JupyterLab Space","local":"creating-your-jupyterlab-space","sections":[],"depth":3},{"title":"Using your JupyterLab Space","local":"using-your-jupyterlab-space","sections":[],"depth":3},{"title":"Dynamically switching between CPUs and GPUs","local":"dynamically-switching-between-cpus-and-gpus","sections":[],"depth":3},{"title":"Customizing your JupyterLab Space","local":"customizing-your-jupyterlab-space","sections":[],"depth":3}],"depth":2},{"title":"Dev Mode: Develop on HF Spaces from your local VS Code","local":"dev-mode-develop-on-hf-spaces-from-your-local-vs-code","sections":[],"depth":2},{"title":"Now write some code!","local":"now-write-some-code","sections":[],"depth":2}],"depth":1}';function Dt(ne){return St(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ut extends Lt{constructor(c){super(),Ct(this,c,Dt,_t,$t,{})}}export{Ut as component};
